#!/bin/bash

set -e

cd "$(dirname "$(readlink "$0")")"

sources=($@)
if [ "${#sources[@]}" -eq 0 ]; then
    sources=(src)
fi

rc=0

run() {
    # remember last failure
    if "$@"; then :; else rc=$?; fi
}

export PYTHONDONTWRITEBYTECODE=1

poetry sync --extras=dev --quiet || poetry sync --extras=dev

echo "flake8:"
run poetry run flake8 "${sources[@]}"
echo "mypy:"
run poetry run mypy

# run formatters?
# black . && isort .

exit $rc
